telegram-cli

Ukoliko imate problema sa instalacijom ili korišćenjem nekog programa, ovo je pravo mesto za vaše pitanje.

Moderators: Slackmuz, Urednik

Post Reply

Administrator
Administrator
offline
User avatar

Posts: 1680
Joined: 07 Jun 2012, 18:01
Location: Najlipši grad na svitu :)

Post Napisano: 09 Oct 2014, 21:56


Telegram-cli je komandnolinijski interfejs za Telegram, open-source messenger sličan WhatsAppu.
Program radi na Linuxu, Windowsima, OS X-u i Androidu te je zbog toga prilično zanimljiv.

Razlog pokretanja teme su problemi koje sam imao prilikom korištenja. Dakle, krenimo:
Prvo sam skinuo alienbobov gotov 32-bitni paket koji je jedno vrijeme radio, ali nedavno je počeo segfaultati. Tada sam, na nagovor kolega sa ##slackware kanala na ircu, odlučio buildati paket i buildanje je javljalo grešku:

Code: Select all

configure: error: no libreadline found
sed: can't read Makefile: No such file or directory
telegram-cli.SlackBuild FAILED at line 225
Nakon provjere:

Code: Select all

ls /usr/lib/libreadline*
sam vidio da libreadline postoji i on je otklonjen kao uzročnik problema.

Tada je na scenu stupio kolega sa ##slackware kanala i rekao da je potreban -ltermcap kao extra lib (lib argument za gcc) te da configure također treba --disable-libconfig.

Čovjek je dao telegram-cli.Slackbuild koji radi:

Code: Select all

#!/bin/sh
# $Id: telegram-cli.SlackBuild,v 1.2 2014/03/05 23:10:42 root Exp root $
# Copyright 2014  Eric Hameleers, Eindhoven, NL
# All rights reserved.
#
#   Permission to use, copy, modify, and distribute this software for
#   any purpose with or without fee is hereby granted, provided that
#   the above copyright notice and this permission notice appear in all
#   copies.
#
#   THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
#   WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
#   MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
#   IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
#   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
#   USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
#   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
#   OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
#   OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
#   SUCH DAMAGE.
# -----------------------------------------------------------------------------
#
# Slackware SlackBuild script 
# ===========================
# By:          Eric Hameleers <alien@slackware.com>
# For:         telegram-cli
# Descr:       telegram messenger CLI
# URL:         https://github.com/vysheng/tg
# Build needs: 
# Needs:       libconfig, lua
# Changelog:   
# 20140305-1:  05/Mar/2014 by Eric Hameleers <alien@slackware.com>
#              * Initial build.
# 
# Run 'sh telegram-cli.SlackBuild' to build a Slackware package.
# The package (.tgz) and .txt file as well as build logs are created in /tmp .
# Install it using 'installpkg'. 
#
# -----------------------------------------------------------------------------

PRGNAM=telegram-cli
SRCNAM=tg
VERSION=${VERSION:-"$(date +%Y%m%d)"}
BUILD=${BUILD:-1}
NUMJOBS=${NUMJOBS:" -j4 "}
TAG=${TAG:-alien}

DOCS="LICENSE* README*"

# Where do we look for sources?
SRCDIR=$(cd $(dirname $0); pwd)

# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
TMP=${TMP:-/tmp/build}
PKG=$TMP/package-$PRGNAM
OUTPUT=${OUTPUT:-/tmp}

# If you want automatic download to work, supply a URL for 'SRCURL' below:
SOURCE="$SRCDIR/${PRGNAM}-${VERSION}.tar.gz"
SRCURL=""
GITURI="https://github.com/vysheng/tg.git"

# Use the src_checkout() function if no downloadable tarball exists.
# This function checks out sources from GIT and creates a tarball of them.
src_checkout() {
  # Param #1 : index in the SOURCE[] array.
  # Param #2 : full path to where SOURCE[$1] tarball should be created.
  # Determine the tarball extension:
  PEXT=$(echo "${2}" | sed -r -e 's/.*[^.].(tar.xz|tar.gz|tar.bz2|tgz).*/\1/')
  case "$PEXT" in
    "tar.xz") TARCOMP="J" ;;
    "tar.gz") TARCOMP="z" ;;
    "tgz") TARCOMP="z" ;;
    "tar.bz2") TARCOMP="j" ;;
    *) echo "Archive can only have extension 'tar.xz', '.tar.gz' '.tar.bz2' or '.tgz'" ; exit 1 ;;
  esac
  # Determine the directory name to create for the archive root:
  PBASE=$(basename ${2} .${PEXT})
  # Determine the directory where we create our checkout:
  CODIR=$(dirname ${2})
  case ${1} in
  0)
     RETDIR=$(pwd)
     mkdir -p $CODIR/${PRGNAM}_temp_checkout_$$ \
       && cd $CODIR/${PRGNAM}_temp_checkout_$$
     mkdir ${PBASE} \
       && git clone ${GITURI} ${PBASE} \
       && cd ${PBASE} \
       && git checkout master \
       && git checkout $(git rev-list -n 1 --before="`date -d $VERSION`" master) \
       && cd .. \
       && chown -R root:root ${PBASE} \
       && tar --exclude .git -${TARCOMP}cf ${2} ${PBASE}
     cd $RETDIR
     rm -rf $CODIR/${PRGNAM}_temp_checkout_$$ || true
     ;;
  *) # Do nothing
     ;;
  esac
}

##
## --- with a little luck, you won't have to edit below this point --- ##
##

# Automatically determine the architecture we're building on:
MARCH=$( uname -m )
if [ -z "$ARCH" ]; then
  case "$MARCH" in
    i?86)    export ARCH=i486 ;;
    armv7hl) export ARCH=$MARCH ;;
    armv6hl) export ARCH=$MARCH ;;
    arm*)    export ARCH=arm ;;
    # Unless $ARCH is already set, use uname -m for all other archs:
    *)       export ARCH=$MARCH ;;
  esac
fi

case "$ARCH" in
  i486)      SLKCFLAGS="-O2 -march=i486 -mtune=i686 -ltermcap"
             SLKLDFLAGS=""; LIBDIRSUFFIX=""
             ;;
  x86_64)    SLKCFLAGS="-O2 -fPIC -ltermcap"
             SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
             ;;
  armv7hl)   SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16 -ltermcap"
             SLKLDFLAGS=""; LIBDIRSUFFIX=""
             ;;
  armv6hl)   SLKCFLAGS="-O2 -march=armv6 -mfpu=vfp -mfloat-abi=hard -ltermcap"
             SLKLDFLAGS=""; LIBDIRSUFFIX=""
             ;;
  *)         SLKCFLAGS=${SLKCFLAGS:-"O2 -ltermcap"}
             SLKLDFLAGS=${SLKLDFLAGS:-""}; LIBDIRSUFFIX=${LIBDIRSUFFIX:-""}
             ;;
esac

case "$ARCH" in
    arm*)    TARGET=$ARCH-slackware-linux-gnueabi ;;
    *)       TARGET=$ARCH-slackware-linux ;;
esac

# Exit the script on errors:
set -e
trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
# Catch unitialized variables:
set -u
P1=${1:-1}

# Save old umask and set to 0022:
_UMASK_=$(umask)
umask 0022

# Create working directories:
mkdir -p $OUTPUT          # place for the package to be saved
mkdir -p $TMP/tmp-$PRGNAM # location to build the source
mkdir -p $PKG             # place for the package to be built
rm -rf $PKG/*             # always erase old package's contents
rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
rm -rf $OUTPUT/{configure,make,install,error,makepkg,patch}-$PRGNAM.log
                          # remove old log files

# Source file availability:
if ! [ -f ${SOURCE} ]; then
  echo "Source '$(basename ${SOURCE})' not available yet..."
  # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
  [ -w "$SRCDIR" ] || SOURCE="$OUTPUT/$(basename ${SOURCE})"
  if [ -f ${SOURCE} ]; then echo "Ah, found it!"; continue; fi
  if ! [ "x${SRCURL}" == "x" ]; then
    echo "Will download file to $(dirname $SOURCE)"
    wget -nv -T 20 -O "${SOURCE}" "${SRCURL}" || true
    if [ $? -ne 0 -o ! -s "${SOURCE}" ]; then
      echo "Fail to download '$(basename ${SOURCE})'. Aborting the build."
      mv -f "${SOURCE}" "${SOURCE}".FAIL
      exit 1
    fi
  else
    # Try if we have a GIT/SVN/CVS download routine for ${SOURCE}
    echo "Will checkout sources to $(dirname $SOURCE)"
    src_checkout 0 "${SOURCE}" 2>&1 > $OUTPUT/checkout-$(basename ${SOURCE}).log
  fi
  if [ ! -f "${SOURCE}" -o ! -s "${SOURCE}" ]; then
    echo "File '$(basename ${SOURCE})' not available. Aborting the build."
    exit 1
  fi
fi

if [ "$P1" == "--download" ]; then
  echo "Download complete."
  exit 0
fi

# --- PACKAGE BUILDING ---

echo "++"
echo "|| $PRGNAM-$VERSION"
echo "++"

cd $TMP/tmp-$PRGNAM
echo "Extracting the source archive(s) for $PRGNAM..."
tar -xvf ${SOURCE}
cd ${PRGNAM}-${VERSION}
chown -R root:root .
chmod -R u+w,go+r-w,a+rX-st .

echo Building ...
LDFLAGS="$SLKLDFLAGS" \
CXXFLAGS="$SLKCFLAGS" \
CFLAGS="$SLKCFLAGS" \
./configure \
  --prefix=/usr \
  --disable-libconfig \
  --libdir=/usr/lib${LIBDIRSUFFIX} \
  --mandir=/usr/man \
  --docdir=/usr/doc/$PRGNAM-$VERSION \
  --localstatedir=/var \
  --sysconfdir=/etc \
  --program-prefix= \
  --program-suffix= \
  --with-progname=${PRGNAM} \
  --build=$TARGET \
  2>&1 | tee $OUTPUT/configure-${PRGNAM}.log

# A fix for Slackware's old readline package:
sed -i -e 's/ledit/lreadline/g' Makefile

make $NUMJOBS 2>&1 | tee $OUTPUT/make-${PRGNAM}.log

# Install the renamed binary:
if [ -f telegram ]; then
  install -D -m0755 telegram $PKG/usr/bin/${PRGNAM}
else
  # new snapshots build telegram-cli in a bin folder
  install -D -m0755 bin/${PRGNAM} $PKG/usr/bin/${PRGNAM}
fi

# Add public key for the server where the client will look for it:
if [ -f tg.pub ] ; then
  install -D -m0644 tg.pub $PKG/etc/${PRGNAM}/server.pub
else
  install -D -m0644 server.pub $PKG/etc/${PRGNAM}/server.pub
fi

# Add documentation:
mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
find $PKG/usr/doc -type f -exec chmod 644 {} \;

# Compress the man page(s):
if [ -d $PKG/usr/man ]; then
  find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
  for i in $(find $PKG/usr/man -type l -name "*.?") ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
fi

# Strip binaries (if any):
find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
  | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true

# Add a package description:
mkdir -p $PKG/install
cat $SRCDIR/slack-desc > $PKG/install/slack-desc
cat $SRCDIR/slack-required > $PKG/install/slack-required

# Build the package:
cd $PKG
makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
cd $OUTPUT
md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz}.md5
cd -
cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
cat $PKG/install/slack-required > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.dep

# Restore the original umask:
umask ${_UMASK_}
Eto, uživajte :)
Udruga SOK - službena stranica
Spreman sam umrijeti časno, ali ako nečasno, onda ništa



Administrator
Administrator
offline
User avatar

Posts: 3451
Joined: 01 Apr 2012, 13:50
Location: Mlečni put

Post Napisano: 09 Oct 2014, 23:55


Da li su ti greške bile kao ove:

Code: Select all

 *** Couldn't open public key file: tg.pub
 *** bad_msg_notification: msg_id = 6068337814835050392, seq = 1, error = 17
 *** bad_msg_notification: msg_id = 6068337814835050396, seq = 2, error = 17
 *** bad_msg_notification: msg_id = 6068337814835050400, seq = 4, error = 17
 *** bad_msg_notification: msg_id = 6068337814835050404, seq = 6, error = 17
I da li je postaljeni slackbuilds zapravo od AlienBoba (kao što piše na početku skripte), onaj koji i stoji kod njega u repou ili je neko menjao za svoje potrebe?

Jesi li probao da obrišeš ~/.telegram-cli pa da probaš program nakon toga? Vidim da se taj problem provlači netom, nema veze sa distribucijom, ali izgleda da ima veze sa satom na računaru kako kažu neki...

Korisni linkovi (nadam se):

o greškama — https://core.telegram.org/mtproto/servi ... t_messages" onclick="window.open(this.href);return false;
prijavljene greške drugih korisnika a vezano za ovaj problem —
https://github.com/vysheng/tg/issues/197" onclick="window.open(this.href);return false;
https://github.com/vysheng/tg/issues/115" onclick="window.open(this.href);return false; i
https://github.com/vysheng/tg/issues/59
Use the source, Luke
SSZ irc kanal
Spread the Word, “CHOOSE SLACK! and Don’t look back.”



Administrator
Administrator
offline
User avatar

Posts: 1680
Joined: 07 Jun 2012, 18:01
Location: Najlipši grad na svitu :)

Post Napisano: 10 Oct 2014, 07:17


greška nije bila takva nego nešto tipa:
malloc nešto pa memorijska lokacija...
nisam probavao brisati .telegram-cli, a skripta je, mislim, malo dorađena
Udruga SOK - službena stranica
Spreman sam umrijeti časno, ali ako nečasno, onda ništa



Administrator
Administrator
offline
User avatar

Posts: 3451
Joined: 01 Apr 2012, 13:50
Location: Mlečni put

Post Napisano: 10 Oct 2014, 10:15


Ok, hvala za info.
Use the source, Luke
SSZ irc kanal
Spread the Word, “CHOOSE SLACK! and Don’t look back.”


Post Reply

Who is online

Users browsing this forum: No registered users and 19 guests